## klystrack 0.20171212

=== klystrack/Makefile ===
TARGET := klystrack
KLYSTRON=../klystron
ECHO := echo
CFG := debug
MACHINE := 
NSIS := C:/program\ files\ \(x86\)/nsis/makensis.exe /V2 /NOCD
WGET := wget --quiet
MAKEBUNDLE := $(KLYSTRON)/tools/bin/makebundle.exe
UPLOAD := cmd.exe /c upload.bat
DLLS := zip/data/SDL2_image.dll zip/data/SDL2.dll
DESTDIR ?= /usr
EXT := .c
CC := gcc -Werror 
CDEP := gcc -E -MM
ARCHIVE := klystrack
INSTALLER := klystrack.exe
SDL_VER := 2.0.4
SDL_IMAGEVER := 2.0.1
THEMES :=
REV := cp -f

CFLAGS := $(MACHINE) -ftree-vectorize -std=gnu99 --no-strict-aliasing

ifdef COMSPEC
	TARGET := $(TARGET).exe
	ARCHIVE := $(ARCHIVE).zip
	SDLFLAGS := -I c:/mingw/include/SDL2
	SDLLIBS :=  -lSDL2main -lSDL2 -lSDL2_image -lwinmm
	CFLAGS += -mthreads 
	ZIP := pkzipc -exclude=.* -zipdate=newest -path=relative -silent -rec -dir -add
	ZIPEXT := pkzipc -ext -silent
else
	ZIP := tar czf
	DLLS = 
	ARCHIVE := $(ARCHIVE).tar.gz
	SDLFLAGS := `sdl2-config --cflags` -U_FORTIFY_SOURCE
	SDLLIBS := `sdl2-config --libs` -lSDL2_image
endif

ifdef COMSPEC
	RES_PATH := .
	CFLAGS += -DRESOURCES_IN_BINARY_DIR
	CONFIG_PATH := ~/.klystrack
else
	RES_PATH ?= $(DESTDIR)/lib/klystrack
	CONFIG_PATH := ~/.klystrack
endif

EXTFLAGS := -DNOSDL_MIXER -DUSESDLMUTEXES -DENABLEAUDIODUMP -DSTEREOOUTPUT -DUSESDL_IMAGE $(EXTFLAGS)
LDFLAGS :=  -L $(KLYSTRON)/bin.$(CFG) -lengine_gfx -lengine_util -lengine_snd -lengine_gui -lm $(SDLLIBS) 
INCLUDEFLAGS := -I src $(SDLFLAGS) -I $(KLYSTRON)/src -L$(KLYSTRON)/bin.$(CFG) -DRES_PATH="$(RES_PATH)" -DCONFIG_PATH="$(CONFIG_PATH)" $(EXTFLAGS) -DKLYSTRON=$(KLYSTRON)

ifdef COMSPEC
	LDFLAGS := -lmingw32 $(LDFLAGS)
endif

DIRS := $(notdir $(wildcard src/*)) 
THEMEDIRS := $(notdir $(wildcard themes/*)) 

ifeq ($(CFG),debug)
 CFLAGS += -g -Wall -DDEBUG -fno-inline 
else
 ifeq ($(CFG),profile)
  CFLAGS += -O3 -pg -Wall 
 else
  ifeq ($(CFG),release)
   CFLAGS += -O3 -Wall -s 
   ifdef COMSPEC
	 CFLAGS += -mwindows
   endif
  else
   @$(ECHO) "Invalid configuration "$(CFG)" specified."
   @$(ECHO) "Possible choices for configuration are "
   @$(ECHO) "'release', 'profile' and 'debug'"
   @exit 1
  endif
 endif
endif

# $(1) = subdir, $(2) = filename prefix (i.e. subdir without a slash)
define directory_defs
 SRC := $$(notdir $$(wildcard src/$(value 1)/*$(EXT))) 
 DEP := $$(patsubst %$(EXT),deps/$(CFG)_$(2)%.d,$$(SRC))
 OBJ := $$(patsubst %$(EXT),objs.$(CFG)/$(2)%.o,$$(SRC))
 
 OBJS := $(OBJS) $$(OBJ)
 DEPS := $(DEPS) $$(DEP)
 
objs.$(CFG)/$(2)%.o: src/$(1)%$(EXT)
	@$(ECHO) "Compiling $$(notdir $$<)..."
	@mkdir -p objs.$(CFG)
	@$(CC) $(INCLUDEFLAGS) -c $(CFLAGS) -o $$@ $$<

deps/$(CFG)_$(2)%.d: src/$(1)%$(EXT)
	@mkdir -p deps
	@$(ECHO) "Generating dependencies for $$(notdir $$<)..."
	@set -e ; $(CDEP) $(INCLUDEFLAGS) $$< > $$@.$$$$$$$$; \
	sed 's,\($$*\)\.o[ :]*,objs.$(CFG)\/$(2)\1.o $$@ : ,g' \
		< $$@.$$$$$$$$ > $$@; \
	rm -f $$@.$$$$$$$$
endef

define theme_defs	

 THEMES := $$(THEMES) res/$(1)

res/$(1): themes/$(1)/* #themes/$(1)/font/* themes/$(1)/font7x6/* themes/$(1)/tiny/* 
	@$(ECHO) "Building theme $(1)..."
	@mkdir -p res
	@mkdir -p themetemp
	@-cp -f themes/$(1)/colors.txt themetemp
	@-cp -f themes/$(1)/bevel.* themetemp
	@-cp -f themes/$(1)/vu.* themetemp
	@-cp -f themes/$(1)/analyzor.* themetemp
	@-cp -f themes/$(1)/logo.* themetemp
	@-cp -f themes/$(1)/catometer.* themetemp
	@-cp -f themes/$(1)/cursor.* themetemp
	@-cp -f themes/$(1)/icon.* themetemp
	-@if test -d themes/$(1)/font; then $(MAKEBUNDLE) themetemp/8x8.fnt themes/$(1)/font ; fi
	-@if test -d themes/$(1)/font7x6; then $(MAKEBUNDLE) themetemp/7x6.fnt themes/$(1)/font7x6 ; fi
	-@if test -d themes/$(1)/tiny; then $(MAKEBUNDLE) themetemp/4x6.fnt themes/$(1)/tiny ; fi
	@-$(MAKEBUNDLE) $$@ themetemp
	@rm -rf themetemp
	
endef

build: Makefile src/version.h src/version_number.h
	@touch src/version
	@make -C $(KLYSTRON) CFG=$(CFG) EXTFLAGS="$(EXTFLAGS)"
	@make all CFG=$(CFG) EXTFLAGS="$(EXTFLAGS)"

src/version.h: src/version
	@echo '#ifndef VERSION_H' > ./src/version.h
	@echo '#define VERSION_H' >> ./src/version.h
	@echo '#include "version_number.h"' >> ./src/version.h
	@echo -n '#define REVISION "' >> ./src/version.h
	@date +"%Y%m%d" | tr -d '\n' >> ./src/version.h
	@echo '"' >> ./src/version.h
	@echo '#define VERSION_STRING "klystrack " VERSION " " REVISION' >> ./src/version.h
	@echo '#endif' >> ./src/version.h
	
src/version_number.h: src/version
	@echo '#ifndef VERSION_NUMBER' > src/version_number.h
	@echo '#define VERSION_NUMBER' >> src/version_number.h
	@echo -n '#define VERSION "' >> src/version_number.h
	@echo -n `cat src/version` >> src/version_number.h
	@echo '"' >> src/version_number.h
	@echo '#endif' >> src/version_number.h

# root (i.e. src/*.c)
$(eval $(call directory_defs,,))
# subdirs (src/*/*.c)
$(foreach dir,$(DIRS),$(eval $(call directory_defs,$(dir)/,$(dir)_)))
# themes
$(foreach dir,$(THEMEDIRS),$(eval $(call theme_defs,$(dir))))

ifdef COMSPEC
  OBJS += objs.$(CFG)/windres.o
endif
  
.PHONY: zip all build nightly installer

all: bin.$(CFG)/$(TARGET) $(THEMES)
	
zip: doc/* $(THEMES) $(DLLS) examples/instruments/* examples/songs/* linux/Makefile $(DLLS)
	@make -C $(KLYSTRON) CFG=release EXTFLAGS="$(EXTFLAGS)"
	@make build CFG=release
	@mkdir -p zip/data/res
	@mkdir -p zip/data/examples/songs
	@mkdir -p zip/data/examples/songs/n00bstar-examples
	@mkdir -p zip/data/examples/instruments
	@mkdir -p zip/data/examples/instruments/n00bstar-instruments
	@cp examples/songs/*.kt zip/data/examples/songs
	@cp examples/songs/n00bstar-examples/*.kt zip/data/examples/songs/n00bstar-examples
	@cp examples/instruments/*.ki zip/data/examples/instruments
	@cp examples/instruments/n00bstar-instruments/*.ki zip/data/examples/instruments/n00bstar-instruments
	@cp res/* zip/data/res
	@mkdir -p zip/data/key
	@cp key/* zip/data/key
	@cp doc/LICENSE zip/data/LICENSE
	@cp doc/SDL.txt zip/data/SDL.txt
	@cp doc/SDL_image.txt zip/data/SDL_image.txt
	@cp doc/Default.kt zip/data/Default.kt
	@cp bin.release/$(TARGET) zip/data/$(TARGET)
ifdef COMSPEC
	@cd zip/data; rm -f ../$(ARCHIVE); $(ZIP) ../$(ARCHIVE) "*"
	@cp -f zip/klystrack.zip zip/klystrack-`cat src/version`-win32.zip
else
	-@rm -f zip/data/Makefile
	cd zip; cp -r data klystrack-`cat ../src/version` ; rm -f $(ARCHIVE); $(ZIP) klystrack-`cat ../src/version`.tar.gz klystrack-`cat ../src/version` ; rm -rf klystrack-`cat ../src/version`
	@cp -f linux/Makefile zip/data
endif
	
installer: zip installer/klystrack.nsi
ifdef COMSPEC
	@$(NSIS) /DVERSION=`cat src/version` installer/klystrack.nsi
endif
	
nightly: zip
	@cp zip/$(ARCHIVE) zip/klystrack-nightly-`date +"%Y%m%d" | tr -d '\n'`-win32.zip
	
clean:
	@rm -rf deps objs.debug objs.release objs.profile bin.release bin.debug bin.profile zip temp res

bin.$(CFG)/$(TARGET): $(OBJS)
	@$(ECHO) "Linking $(TARGET)..."
	@mkdir -p bin.$(CFG)
	@$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)

release: bin.release/$(TARGET)
	@$(ECHO) "Building release -->"
	
#bin.release/$(TARGET): 
#	@make CFG=release
	
ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

zip/data/SDL2_image.dll:
	@$(ECHO) "Downloading "$@"..."
	@mkdir -p temp
	@cd temp ; $(WGET) http://www.libsdl.org/projects/SDL_image/release/SDL2_image-$(SDL_IMAGEVER)-win32-x86.zip ; $(ZIPEXT) SDL2_image-$(SDL_IMAGEVER)-win32-x86.zip SDL2_image.dll libpng16-16.dll zlib1.dll ; rm SDL2_image-$(SDL_IMAGEVER)-win32-x86.zip
	@mkdir -p zip/data
	@mv temp/SDL2_image.dll zip/data/SDL2_image.dll
	@mv temp/libpng16-16.dll zip/data/libpng16-16.dll
	@mv temp/zlib1.dll zip/data/zlib1.dll

zip/data/SDL2.dll:
	@$(ECHO) "Downloading "$@"..."
	@mkdir -p temp
	@cd temp ; $(WGET) https://www.libsdl.org/release/SDL2-$(SDL_VER)-win32-x86.zip ; $(ZIPEXT) SDL2-$(SDL_VER)-win32-x86.zip SDL2.dll ; rm SDL2-$(SDL_VER)-win32-x86.zip
	@mkdir -p zip/data
	@mv temp/SDL2.dll zip/data/SDL2.dll
	
	
objs.$(CFG)/windres.o: windres/* icon/*
	windres -i windres/resource.rc -o $@

=== klystron/Makefile ===
TARGET=engine
VPATH=src:src
ECHO = echo
CFG = debug
REV = cp -f
MACHINE = 

util_SRC = $(notdir ${wildcard src/util/*.c}) 
util_DEP = $(patsubst %.c, deps/util_$(CFG)_%.d, ${util_SRC})
util_OBJ = $(patsubst %.c, objs.$(CFG)/util_%.o, ${util_SRC})

snd_SRC = $(notdir ${wildcard src/snd/*.c}) 
snd_DEP = $(patsubst %.c, deps/snd_$(CFG)_%.d, ${snd_SRC})
snd_OBJ = $(patsubst %.c, objs.$(CFG)/snd_%.o, ${snd_SRC}) 

gfx_SRC = $(notdir ${wildcard src/gfx/*.c}) 
gfx_DEP = $(patsubst %.c, deps/gfx_$(CFG)_%.d, ${gfx_SRC})
gfx_OBJ = $(patsubst %.c, objs.$(CFG)/gfx_%.o, ${gfx_SRC}) 

gui_SRC = $(notdir ${wildcard src/gui/*.c}) 
gui_DEP = $(patsubst %.c, deps/gui_$(CFG)_%.d, ${gui_SRC})
gui_OBJ = $(patsubst %.c, objs.$(CFG)/gui_%.o, ${gui_SRC}) $(util_OBJ) $(gfx_OBJ)

lib_SRC = $(notdir ${wildcard src/lib/*.c}) 
lib_DEP = $(patsubst %.c, deps/lib_$(CFG)_%.d, ${lib_SRC})
lib_OBJ = $(patsubst %.c, objs.$(CFG)/lib_%.o, ${lib_SRC}) 
	
CC = gcc -shared -std=gnu99 --no-strict-aliasing
CDEP = gcc -E -std=gnu99

ifndef CFLAGS
CFLAGS = $(MACHINE) -ftree-vectorize
endif

# What include flags to pass to the compiler
ifdef COMSPEC
	SDLFLAGS = -I /MinGW/include/SDL2 -lSDL2 -lwinmm
else
	SDLFLAGS = `sdl2-config --cflags` -U_FORTIFY_SOURCE
endif

INCLUDEFLAGS= -I ../Common -I src $(SDLFLAGS) -I src/gfx -I src/snd -I src/util -I src/gui $(EXTFLAGS)

# Separate compile options per configuration
ifeq ($(CFG),debug)
	CFLAGS += -O3 -g -Wall ${INCLUDEFLAGS} -DDEBUG -fno-inline 
else
	ifeq ($(CFG),profile)
		CFLAGS += -O3 -pg -Wall ${INCLUDEFLAGS}
	else
		ifeq ($(CFG),release)
			CFLAGS += -O3 -Wall ${INCLUDEFLAGS} -s
		else
			ifeq ($(CFG),size)
				CFLAGS += -Os -Wall ${INCLUDEFLAGS} -s -ffast-math -fomit-frame-pointer -DREDUCESIZE
			else
				@$(ECHO) "Invalid configuration "$(CFG)" specified."
				@$(ECHO) "You must specify a configuration when "
				@$(ECHO) "running make, e.g. make CFG=debug"
				@$(ECHO) "Possible choices for configuration are "
				@$(ECHO) "'release', 'profile', 'size' and 'debug'"
				@exit 1
			endif
		endif
	endif
endif

# A common link flag for all configurations
LDFLAGS = 

.PHONY: tools all build

build: Makefile
	@echo '#ifndef KLYSTRON_VERSION_H' > ./src/version.h
	@echo '#define KLYSTRON_VERSION_H' >> ./src/version.h
	@echo -n '#define KLYSTRON_REVISION "' >> ./src/version.h
	@date +"%Y%m%d" | tr -d '\n' >> ./src/version.h
	@echo '"' >> ./src/version.h
	@echo '#define KLYSTRON_VERSION_STRING "klystron " KLYSTRON_REVISION' >> ./src/version.h
	@echo '#endif' >> ./src/version.h
	make all CFG=$(CFG)

all: bin.$(CFG)/lib${TARGET}_snd.a bin.$(CFG)/lib${TARGET}_gfx.a bin.$(CFG)/lib${TARGET}_util.a bin.$(CFG)/lib${TARGET}_gui.a tools

ksnd: bin.$(CFG)/libksndstatic.a bin.$(CFG)/ksnd.dll

ifdef COMSPEC
tools: tools/bin/makebundle.exe tools/bin/editor.exe
else
tools: tools/bin/makebundle.exe 
endif

inform:
	@echo "Configuration "$(CFG)
	@echo "------------------------"
	
bin.$(CFG)/lib${TARGET}_snd.a: ${snd_OBJ} | inform
	@$(ECHO) "Linking "$(TARGET)"..."
	@mkdir -p bin.$(CFG)
	@ar rcs $@ $^
	
bin.$(CFG)/lib${TARGET}_gfx.a: ${gfx_OBJ} | inform
	@$(ECHO) "Linking "$(TARGET)"..."
	@mkdir -p bin.$(CFG)
	@ar rcs $@ $^
	
bin.$(CFG)/lib${TARGET}_util.a: ${util_OBJ} | inform
	@$(ECHO) "Linking "$(TARGET)"..."
	@mkdir -p bin.$(CFG)
	@ar rcs $@ $^
	
bin.$(CFG)/lib${TARGET}_gui.a: ${gui_OBJ} | inform
	@$(ECHO) "Linking "$(TARGET)"..."
	@mkdir -p bin.$(CFG)
	@ar rcs $@ $^

bin.$(CFG)/libksndstatic.a: objs.$(CFG)/lib_ksnd.o ${snd_OBJ} | inform
	@$(ECHO) "Linking "$(TARGET)"..."
	@mkdir -p bin.$(CFG)
	@ar rcs $@ $^
ifdef COMSPEC
	@$(ECHO) "Building ksndstatic.lib..."
	@-lib /OUT:bin.$(CFG)/ksndstatic.lib $^
endif
	
bin.$(CFG)/ksnd.dll: objs.$(CFG)/lib_ksnd.o ${snd_OBJ} src/lib/ksnd.def | inform
	@$(ECHO) "Linking ksnd.dll..."
	@mkdir -p bin.$(CFG)
	@$(CC) -shared -o $@ objs.$(CFG)/lib_ksnd.o src/lib/ksnd.def ${snd_OBJ} $(CFLAGS) $(INCLUDEFLAGS) -DDLLEXPORT -Wl,--out-implib,bin.$(CFG)/libksnd.a
ifdef COMSPEC
	@$(ECHO) "Building ksnd.lib..."
	@-lib /DEF:src/lib/ksnd.def /OUT:bin.$(CFG)/ksnd.lib
endif
	
objs.$(CFG)/snd_%.o: snd/%.c 
	@$(ECHO) "Compiling "$(notdir $<)"..."
	@mkdir -p objs.$(CFG)
	@$(CC) -c $(CFLAGS) -o $@ $<

objs.$(CFG)/gfx_%.o: gfx/%.c 
	@$(ECHO) "Compiling "$(notdir $<)"..."
	@mkdir -p objs.$(CFG)
	@$(CC) -c $(CFLAGS) -o $@ $<

objs.$(CFG)/util_%.o: util/%.c
	@$(ECHO) "Compiling "$(notdir $<)"..."
	@mkdir -p objs.$(CFG)
	@$(CC) -c $(CFLAGS) -o $@ $<

objs.$(CFG)/gui_%.o: gui/%.c
	@$(ECHO) "Compiling "$(notdir $<)"..."
	@mkdir -p objs.$(CFG)
	@$(CC) -c $(CFLAGS) -o $@ $<
	
objs.$(CFG)/lib_%.o: lib/%.c
	@$(ECHO) "Compiling "$(notdir $<)"..."
	@mkdir -p objs.$(CFG)
	@$(CC) -c $(CFLAGS) -o $@ $<

deps/snd_$(CFG)_%.d: snd/%.c 
	@mkdir -p deps
	@$(ECHO) "Generating dependencies for $<"
	@set -e ; $(CDEP) -MM $(INCLUDEFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,objs.$(CFG)\/snd_\1.o $@ : ,g' \
		< $@.$$$$ > $@; \
	rm -f $@.$$$$

deps/gfx_$(CFG)_%.d: gfx/%.c 
	@mkdir -p deps
	@$(ECHO) "Generating dependencies for $<"
	@set -e ; $(CDEP) -MM $(INCLUDEFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,objs.$(CFG)\/gfx_\1.o $@ : ,g' \
		< $@.$$$$ > $@; \
	rm -f $@.$$$$

deps/util_$(CFG)_%.d: util/%.c
	@mkdir -p deps
	@$(ECHO) "Generating dependencies for $<"
	@set -e ; $(CDEP) -MM $(INCLUDEFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,objs.$(CFG)\/util_\1.o $@ : ,g' \
		< $@.$$$$ > $@; \
	rm -f $@.$$$$

deps/gui_$(CFG)_%.d: gui/%.c
	@mkdir -p deps
	@$(ECHO) "Generating dependencies for $<"
	@set -e ; $(CDEP) -MM $(INCLUDEFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,objs.$(CFG)\/gui_\1.o $@ : ,g' \
		< $@.$$$$ > $@; \
	rm -f $@.$$$$
	
deps/lib_$(CFG)_%.d: lib/%.c
	@mkdir -p deps
	@$(ECHO) "Generating dependencies for $<"
	@set -e ; $(CDEP) -MM $(INCLUDEFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,objs.$(CFG)\/gui_\1.o $@ : ,g' \
		< $@.$$$$ > $@; \
	rm -f $@.$$$$
	
clean:
	@rm -rf deps objs.release objs.debug objs.profile objs.size bin.release bin.debug bin.profile bin.size

# Unless "make clean" is called, include the dependency files
# which are auto-generated. Don't fail if they are missing
# (-include), since they will be missing in the first 
# invocation!
ifneq ($(MAKECMDGOALS),clean)
-include ${snd_DEP}
-include ${gfx_DEP}
-include ${util_DEP}
-include ${gui_DEP}
-include ${lib_DEP}
endif

tools/bin/makebundle.exe: tools/makebundle/*.c
	make -C tools/makebundle 

ifdef COMSPEC
tools/bin/editor.exe: tools/editor/src/*
	make -C tools/editor
	cp tools/editor/bin.$(CFG)/editor.exe tools/bin/editor.exe
endif

=== klystrack/linux/Makefile ===
# linux installer makefile

TARGET=klystrack
RES_PATH = $(DESTDIR)/usr/lib/klystrack

install: 
	@mkdir -p $(DESTDIR)/usr/bin
	@cp -f $(TARGET) $(DESTDIR)/usr/bin/$(TARGET)
	@mkdir -p $(RES_PATH)
	@cp -Rf res $(RES_PATH)
	@cp -Rf key $(RES_PATH)
	@cp -Rf examples $(RES_PATH)
	@mkdir -p $(DESTDIR)/usr/share/doc/klystrack
	@cp LICENSE $(DESTDIR)/usr/share/doc/klystrack
	@cp SDL.txt $(DESTDIR)/usr/share/doc/klystrack
	@cp SDL_image.txt $(DESTDIR)/usr/share/doc/klystrack
	
clean:

=== klystrack/player/Makefile ===
ifdef COMSPEC
 SDL := -lSDL2main -lSDL2 -I /mingw/include/SDL2
 LIBS := -lmingw32 -lengine_snd 
else
 SDL := `sdl-config --libs` 
 LIBS := -lengine_snd 
endif

player.exe: player.c
	gcc -DUSESDLMUTEXES -DSTEREOOUTPUT -DENABLEAUDIODUMP -DNOSDL_MIXER -DDEBUG -o player.exe player.c -g -Wall $(LIBS) $(SDL) -I ../../klystron/src -L ../../klystron/bin.debug

=== klystrack/scancode-tool/Makefile ===
CC = gcc -s -Ic:/MinGW/include/SDL2
EXE = scancode.exe

$(EXE): scancode.c
	$(CC) -o $@ $^ -lmingw32 -lSDL2main -lSDL2

=== klystron/tools/editor/Makefile ===
TARGET=editor.exe
VPATH=src:src
ECHO = echo
CFG = debug
MACHINE = -march=pentium2 

# The directories containing the source files, separated by ':'


# To make "debug" the default (if invoked with just "make"):
#
# ifeq ($(CFG),)
# CFG=debug
# endif

# The source files: regardless of where they reside in 
# the source tree, VPATH will locate them...
Group0_SRC = $(notdir ${wildcard src/*.c})

# Build a Dependency list and an Object list, by replacing 
# the .cpp extension to .d for dependency files, and .o for 
# object files.
Group0_DEP = $(patsubst %.c, deps/Group0_%.d, ${Group0_SRC})
Group0_OBJ = $(patsubst %.c, objs.$(CFG)/Group0_%.o, \
	${Group0_SRC}) 


	
# What compiler to use for generating dependencies: 
# it will be invoked with -MM
CXX = gcc -std=c99 --no-strict-aliasing 
CXXDEP = gcc -E -std=c99

# What include flags to pass to the compiler

CXXFLAGS = $(MACHINE) -ftree-vectorize

ifdef COMSPEC
	CXXFLAGS += -mthreads
	INCLUDEFLAGS := -I ../Common -I src -I /MinGW/include/SDL2 -I ../../src 
else
	INCLUDEFLAGS := `sdl-config --cflags` -U_FORTIFY_SOURCE -I ../../src 
endif

LDFLAGS = -L ../../bin.$(CFG) -lengine_gfx -lengine_util -lengine_gui -lmingw32 -lSDL2_image -lSDLmain -lSDL2 -lconfig 

# Separate compile options per configuration
ifeq ($(CFG),debug)
CXXFLAGS += -O3 -g -Wall ${INCLUDEFLAGS} -DDEBUG
else
ifeq ($(CFG),profile)
CXXFLAGS += -O3 -g -pg -Wall ${INCLUDEFLAGS}
else
ifeq ($(CFG),release)
CXXFLAGS += -O3 -g -Wall ${INCLUDEFLAGS}
else
@$(ECHO) "Invalid configuration "$(CFG)" specified."
@$(ECHO) "You must specify a configuration when "
@$(ECHO) "running make, e.g. make CFG=debug"
@$(ECHO) "Possible choices for configuration are "
@$(ECHO) "'release', 'profile' and 'debug'"
@exit 1
exit
endif
endif
endif

all:	inform bin.$(CFG)/${TARGET} 

inform:
	@echo "Configuration "$(CFG)
	@echo "------------------------"

bin.$(CFG)/${TARGET}: ${Group0_OBJ} | inform
	@mkdir -p bin.$(CFG)
	$(CXX) $(CXXFLAGS) -o $@ $^ ${LDFLAGS}

objs.$(CFG)/Group0_%.o: %.c
	@mkdir -p objs.$(CFG)
	$(CXX) $(CXXFLAGS) -c $(CXXFLAGS) -o $@ $<

deps/Group0_%.d: %.c
	@mkdir -p deps
	@$(ECHO) "Generating dependencies for $<"
	@set -e ; $(CXXDEP) -MM $(INCLUDEFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,objs.$(CFG)\/Group0_\1.o $@ : ,g' \
		< $@.$$$$ > $@; \
	rm -f $@.$$$$

clean:
	@rm -rf deps objs.$(CFG) bin.$(CFG)

# Unless "make clean" is called, include the dependency files
# which are auto-generated. Don't fail if they are missing
# (-include), since they will be missing in the first 
# invocation!
ifneq ($(MAKECMDGOALS),clean)
-include ${Group0_DEP}
endif

=== klystron/tools/makebundle/Makefile ===
TARGET = ../bin/makebundle.exe

ifdef COMSPEC
SDL = -I /mingw/include/sdl 
else
SDL = `sdl2-config --cflags`
endif

$(TARGET): makebundle.c ../../src/util/bundle.h
	@mkdir -p ../bin
	gcc -o $(TARGET) -D_XOPEN_SOURCE makebundle.c -std=c99 -I ../../src $(SDL) -Wall -O3

=== debian/changelog ===
klystrack (0.20171212-2) unstable; urgency=medium

  * Upstream patch to fix building problems. (Closes: #886375)
  * Bump standards version to 4.1.3.
  * Bump debhelper version to 11.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 08 Jan 2018 09:03:36 +0100

klystrack (0.20171212-1) unstable; urgency=medium

  * Initial release (Closes: #884279)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 12 Dec 2017 15:02:26 +0100

=== debian/control ===
Source: klystrack
Section: sound
Priority: optional
Maintainer: Debian Multimedia Packages Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libsdl2-image-dev, libsdl2-dev
Standards-Version: 4.1.3
Homepage: https://github.com/kometbomb/klystrack

Package: klystrack
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Chiptune tracker
 This is an application for creating music reminiscent of the style of music
 from 8-bit computers or, chiptunes. It features a "tracker" style sequencer,
 and a built-in synthesizer capable of a wide range sounds - including but not
 limited to basic subtractive synthesis, frequency modulation and sample
 playback. Sounds can be easily beefed up by using the effect chain. It is
 possbile to import a handful of file formats, including Protracker .MOD,
 Fasttracker 2 .XM, the Cave Story music format (.ORG) and Rob Hubbard 
 Commodore 64 SID files. Tunes can be easily exported as a single mixdown .WAV
 or separate tracks or you can simply use the playback library to use the
 klystrack files in your own games and other software.

=== debian/rules ===
#!/usr/bin/make -f
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --sourcedirectory=klystrack

override_dh_auto_build:
	dh_auto_build -- CFG=release

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/kometbomb/klystrack/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
